=== massxpert/CMakeLists.txt ===
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

if(APPLE)
	set(TARGET massXpert)
	message(STATUS "APPLE target name: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET massxpert)
	message(STATUS "NON-APPLE target name: ${TARGET}")
elseif(WIN64)
	set(TARGET massXpert)
	message(STATUS "WIN64: ${TARGET}")
endif()

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")

#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB MASSXPERT_nongui_SRCS nongui/*.cpp)
file(GLOB MASSXPERT_gui_SRCS gui/*.cpp)
file(GLOB MASSXPERT_SRCS *.cpp)
file(GLOB MASSXPERT_UIS gui/ui/*.ui)

# The appstream, desktop and icon files
if(UNIX AND NOT APPLE)
	install(FILES org.msxpertsuite.massxpert.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)

	install(FILES org.msxpertsuite.massxpert.appdata.xml
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo)

	install(FILES ../images/icons/16x16/massxpert.png
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/16x16/apps/massxpert.png)

	install(FILES ../images/icons/32x32/massxpert.png
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/32x32/apps/massxpert.png)

	install(FILES ../images/icons/48x48/massxpert.png
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/48x48/apps/massxpert.png)

	install(FILES ../images/icons/64x64/massxpert.png
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/64x64/apps/massxpert.png)
endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

qt5_wrap_ui(MASSXPERT_UIS_H ${MASSXPERT_UIS})

qt5_add_resources(MASSXPERT_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${MASSXPERT_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${MASSXPERT_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


###############################################################
# Configuration of the binary to be built
###############################################################

if(NOT APPLE)
	add_executable(${TARGET}
		${MASSXPERT_nongui_SRCS}
		${MASSXPERT_gui_SRCS}
		${MASSXPERT_SRCS}
		${MASSXPERT_UIS_H}
		${MASSXPERT_QRC_CPP})
else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${MASSXPERT_nongui_SRCS}
		${MASSXPERT_gui_SRCS}
		${MASSXPERT_SRCS}
		${MASSXPERT_UIS_H}
		${MASSXPERT_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)
	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")
	set(MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MASSXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/javascript/massxpert)
	set(MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/massxpert)
	set(MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc/massxpert)
elseif(UNIX AND NOT APPLE)
	set(MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MASSXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/javascript)
	set(MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/data)
	set(MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/msxpertsuite-massxpert)
elseif(APPLE)
	SET (BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/massXpert.app)
	SET(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	SET (MASSXPERT_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	SET (MASSXPERT_JAVASCRIPT_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/javascript)
	SET (MASSXPERT_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/data)
	SET (MASSXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/doc)
endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MASSXPERT_BIN_DIR: ${MASSXPERT_BIN_DIR}")
message(STATUS "MASSXPERT_JAVASCRIPT_DIR: ${MASSXPERT_JAVASCRIPT_DIR}")
message(STATUS "MASSXPERT_DATA_DIR: ${MASSXPERT_DATA_DIR}")
message(STATUS "MASSXPERT_DOC_DIR: ${MASSXPERT_DOC_DIR}")

# Prepare various directory names for the parent directory to use later.
set_directory_properties(PROPERTIES CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set_directory_properties(PROPERTIES MASSXPERT_TARGET_NAME ${TARGET})
set_directory_properties(PROPERTIES MASSXPERT_BIN_DIR ${MASSXPERT_BIN_DIR})
set_directory_properties(PROPERTIES MASSXPERT_JAVASCRIPT_DIR ${MASSXPERT_JAVASCRIPT_DIR})
set_directory_properties(PROPERTIES MASSXPERT_DATA_DIR ${MASSXPERT_DATA_DIR})
set_directory_properties(PROPERTIES MASSXPERT_DOC_DIR ${MASSXPERT_DOC_DIR})

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


# On WIN64 we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -LC:/msys64/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include/pwiz")
elseif(APPLE)
	include_directories(/opt/local/include/pwiz)
	link_directories(/opt/local/lib)
else()
	include_directories(/usr/include/proteowizard)
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)


##############################################################
# libIsoSpec++ for calculating isotopic clusters
message(STATUS "${BoldYellow}Link against the libIsoSpec++ library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include")
elseif(APPLE)
	include_directories("/opt/local/include")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	IsoSpec++)


##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})

#message(STATUS "Now printing all the include directories -I...")

#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "included dir='${dir}'")
#endforeach()

#message(STATUS "Now printing all the linking directories -L...")

#get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "link directory dir='${dir}'")
#endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)


if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()


if(NOT APPLE)
	# We want to install the binary arch-dependent target in
	# specific situations. To have proper control, we define the arch
	# component.
	install(TARGETS ${TARGET}
		RUNTIME
		COMPONENT arch
		DESTINATION ${MASSXPERT_BIN_DIR})
endif()


#############################################################
###################
# BUILD OF THE DATA

#################
# process subdirs
add_subdirectory(data)


message("")
message(STATUS "${BoldGreen}Finished configuring of the massXpert submodule.${ColourReset}")
message("")
