=== doc/user-manuals/CMakeLists.txt ===
add_subdirectory(massxpert)
add_subdirectory(minexpert)
