=== minexpert/data/CMakeLists.txt ===
INSTALL (DIRECTORY sample-files
  DESTINATION ${MOBXPERT_DATA_DIR})
