=== minexpert/javascript/CMakeLists.txt ===
###############
# install stuff

INSTALL (DIRECTORY scripts
	DESTINATION ${MINEXPERT_JAVASCRIPT_DIR})
