=== doc/user-manuals/massxpert/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuring of the massXpert user manual documentation${ColourReset}")
message("")

# The massxpert user documentation.
if(UNIX AND NOT APPLE)

	# Command:
	# make massxpert-doc
	# Makes use of the local  Makefile file.
	# Will generate HTML and PDF documentation in the build directory
	add_custom_target(massxpert-doc ALL
		COMMAND make all
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMENT "DocBook-based user manual documentation for massXpert")

endif(UNIX AND NOT APPLE)

install(FILES
	${CMAKE_CURRENT_SOURCE_DIR}/build/massxpert-user-manual/massxpert-doc.pdf
	DESTINATION ${MASSXPERT_DOC_DIR})

install(DIRECTORY 
	${CMAKE_CURRENT_SOURCE_DIR}/build/massxpert-user-manual/html/massxpert-user-manual/
	DESTINATION ${MASSXPERT_DOC_DIR}/html)

message("")
message(STATUS "${BoldGreen}Finished configuring of the massXpert user manual documentation${ColourReset}")
message("")
