=== debian/changelog ===
msxpertsuite (5.8.9-1) unstable; urgency=low

  * Fix filenames of the STIX2 fonts used for the user manual. The bug was
    reported by Lucas Nussbaum <lucas@debian.org>. Thanks to Juhani Numminen
    <juhaninumminen0@gmail.com> and Dennis Filder <d.filder@web.de> for
    suggesting fixes (Closes: #982718).

  * Standards-Version: 4.5.1: no changes required.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 20 Feb 2021 16:18:00 +0100

msxpertsuite (5.8.8-1) unstable; urgency=low

  * New upstream release.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 29 Jun 2020 22:21:39 +0200
