=== debian/watch ===
version=4

https://sourcesup.renater.fr/frs/?group_id=3534 .*/msxpertsuite-@ANY_VERSION@@ARCHIVE_EXT@
